/*
 * Copyright (C) 2009 - 2010 Funambol, Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by
 * the Free Software Foundation with the addition of the following permission
 * added to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED
 * WORK IN WHICH THE COPYRIGHT IS OWNED BY FUNAMBOL, FUNAMBOL DISCLAIMS THE
 * WARRANTY OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program; if not, see http://www.gnu.org/licenses or write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301 USA.
 *
 * You can contact Funambol, Inc. headquarters at 643 Bair Island Road, Suite
 * 305, Redwood City, CA 94063, USA, or at email address info@funambol.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License
 * version 3, these Appropriate Legal Notices must retain the display of the
 * "Powered by Funambol" logo. If the display of the logo is not reasonably
 * feasible for technical reasons, the Appropriate Legal Notices must display
 * the words "Powered by Funambol".
 */
/* $Id$ */

#pragma once

#include "Logger/Logger.h"

//namespace NS_Logging
//{
//	class Logger;
//	Logger& GetLogger(const char* name);
//}

// Get logger for NAME
#define GLINFO(NAME, ...)	\
	LOG_INFO_(NS_Logging::GetLogger(NAME),##__VA_ARGS__);

#define GLDEBUG(NAME, ...)	\
	LOG_DEBUG_(NS_Logging::GetLogger(NAME),##__VA_ARGS__);

#define GLERROR(NAME, ...)	\
	LOG_ERROR_(NS_Logging::GetLogger(NAME),##__VA_ARGS__);

// Get_Defaul_Logger - get logger for defined default variable c_LogName (should bedefined by user)
#define GDLINFO(...)	\
	LOG_INFO_(NS_Logging::GetLogger(c_LogName),##__VA_ARGS__);

#define GDLWARN(...)	\
	LOG_INFO_(NS_Logging::GetLogger(c_LogName),##__VA_ARGS__);

#define GDLDEBUG(...)	\
	LOG_DEBUG_(NS_Logging::GetLogger(c_LogName),##__VA_ARGS__);

#define GDLERROR(...)	\
	LOG_ERROR_(NS_Logging::GetLogger(c_LogName),##__VA_ARGS__);

#define GDLDUMP(...)	\
	LOG_DUMP_(NS_Logging::GetLogger(c_LogName),##__VA_ARGS__);

#define GDCRITICAL(...)	\
	LOG_CRITICAL_(NS_Logging::GetLogger(c_LogName),##__VA_ARGS__);


// use following macroses with declared variable m_logger
#define LDEBUG(msg, ...) LOG_DEBUG_(m_logger, msg,##__VA_ARGS__)
#define LERROR(msg, ...) LOG_ERROR_(m_logger, msg,##__VA_ARGS__)
#define LINFO(msg, ...)  LOG_INFO_(m_logger, msg,##__VA_ARGS__)
#define LWARN(msg, ...) LOG_WARNING_(m_logger, msg,##__VA_ARGS__)
#define LDUMP(msg, ...) LOG_DUMP_(m_logger, msg,##__VA_ARGS__)
#define LCRITICAL(msg, ...) LOG_CRITICAL_(m_logger, msg,##__VA_ARGS__)
